var app;
(function (app) {
    (function (core) {
        (function (controllers) {
            var CoreController = (function () {
                function CoreController($scope) {
                    $scope.showError = this.showError;
                }
                CoreController.prototype.showError = function (ngModelController, error) {
                    if (ngModelController.$dirty) {
                        return ngModelController.$error[error];
                    }
                    return false;
                };

                CoreController.prototype.createCacheObjectIfNeeded = function () {
                    if (!this.cacheObject) {
                        var injector = angular.element('[data-ng-app="app"]').injector();
                        var cacheService = injector.get('$cacheFactory');
                        this.cacheObject = cacheService.get('controllerCache');
                        if (!this.cacheObject) {
                            this.cacheObject = cacheService('controllerCache');
                        }
                    }
                };

                CoreController.prototype.AddToCache = function (key, value) {
                    this.createCacheObjectIfNeeded();
                    this.cacheObject.put(key, value);
                };

                CoreController.prototype.GetFromCache = function (key) {
                    this.createCacheObjectIfNeeded();
                    return this.cacheObject.get(key);
                };
                return CoreController;
            })();
            controllers.CoreController = CoreController;
        })(core.controllers || (core.controllers = {}));
        var controllers = core.controllers;
    })(app.core || (app.core = {}));
    var core = app.core;
})(app || (app = {}));
//# sourceMappingURL=appController.js.map
