var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var app;
(function (app) {
    /// <reference path="../../../Scripts/typings/angularjs/angular.d.ts" />
    (function (directives) {
        var BaseDirective = (function () {
            function BaseDirective() {
                this.isEmpty = function (value) {
                    return angular.isUndefined(value) || value === '' || value === null || value !== value;
                };
            }
            BaseDirective.getControllerFromParameterArray = function (controller) {
                var currentController;
                if (angular.isArray(controller) && controller.length > 0) {
                    currentController = controller[0];
                } else {
                    currentController = controller;
                }
                return currentController;
            };
            return BaseDirective;
        })();
        directives.BaseDirective = BaseDirective;

        var NoClickDirective = (function (_super) {
            __extends(NoClickDirective, _super);
            function NoClickDirective() {
                _super.call(this);
                this.restrict = 'A';
                this.link = function (scope, element) {
                    element.click(function (eventObject) {
                        eventObject.preventDefault();
                    });
                };
            }
            return NoClickDirective;
        })(app.directives.BaseDirective);
        directives.NoClickDirective = NoClickDirective;

        var PaginationDirective = (function (_super) {
            __extends(PaginationDirective, _super);
            function PaginationDirective() {
                _super.call(this);
                var that = this;
                that.currentPage = 0;
                this.restrict = 'A';
                that.currentlyShownPages = [];

                this.link = function (scope, instanceElement, instanceAttributes) {
                    instanceElement.addClass('pagination');
                    var searchFunc;
                    if (instanceAttributes.$attr['gotoPageFunction']) {
                        searchFunc = instanceElement.attr(instanceAttributes.$attr['gotoPageFunction']);
                    } else {
                        searchFunc = "gotoPage";
                    }

                    var handleButtonClick = function (eventObject) {
                        eventObject.preventDefault();
                        var jQueryTarget = angular.element(eventObject.delegateTarget);
                        if (!jQueryTarget.hasClass("disabled")) {
                            var page = eventObject.data['page'];
                            var pageNumber;
                            if (page === '>') {
                                pageNumber = that.currentPage + 1;
                                if (pageNumber > that.totalPages) {
                                    pageNumber = that.totalPages;
                                }
                            } else if (page === '>>') {
                                pageNumber = that.totalPages;
                            } else if (page === '<<') {
                                pageNumber = 1;
                            } else if (page === '<') {
                                pageNumber = that.currentPage - 1;
                                if (pageNumber < 1) {
                                    pageNumber = 1;
                                }
                            } else {
                                pageNumber = parseInt(page);
                            }
                            that.currentPage = pageNumber;
                            scope.$apply(searchFunc + '(' + pageNumber.toString() + ')');
                        }
                    };

                    var hasPageButton = function () {
                        var returnValue = false;
                        angular.forEach(instanceElement.children(), function (item) {
                            var jqueryObject = angular.element(item);
                            if (jqueryObject.text() === that.currentPage.toString()) {
                                returnValue = true;
                            }
                        });
                        return returnValue;
                    };

                    var refresh = function (goToFirstPage) {
                        if (instanceAttributes.$attr['pageCount']) {
                            that.totalPages = scope.$eval(instanceElement.attr(instanceAttributes.$attr["pageCount"]));
                        } else {
                            that.totalPages = scope.$eval("pageCount");
                        }

                        if (instanceAttributes.$attr['currentPage']) {
                            that.currentPage = scope.$eval(instanceElement.attr(instanceAttributes.$attr["currentPage"]));
                        } else {
                            that.currentPage = scope.$eval("currentPage");
                        }

                        if (that.totalPages > 0) {
                            var resetPage = goToFirstPage || (that.currentPage > that.totalPages);
                            if (resetPage) {
                                that.currentPage = 1;
                            }
                            var needToReset = (!hasPageButton()) || goToFirstPage;
                            if (needToReset) {
                                instanceElement.empty();
                                var maxButtons = 5;
                                var firstPageNumber = that.currentPage;
                                while ((firstPageNumber + 4) > that.totalPages) {
                                    firstPageNumber--;
                                }
                                if (firstPageNumber < 1) {
                                    firstPageNumber = 1;
                                }
                                that.currentlyShownPages = [];
                                for (var i = firstPageNumber; i <= that.totalPages; i++) {
                                    if (i < firstPageNumber + maxButtons) {
                                        that.currentlyShownPages.push(i);
                                    } else {
                                        break;
                                    }
                                }

                                instanceElement.append(PaginationDirective.createButton('<<', handleButtonClick));
                                instanceElement.append(PaginationDirective.createButton('<', handleButtonClick));
                                for (var j = 0; j < that.currentlyShownPages.length; j++) {
                                    var button = PaginationDirective.createButton(that.currentlyShownPages[j].toString(), handleButtonClick);
                                    instanceElement.append(button);
                                }
                                instanceElement.append(PaginationDirective.createButton('>', handleButtonClick));
                                instanceElement.append(PaginationDirective.createButton('>>', handleButtonClick));
                            }

                            angular.forEach(instanceElement.children(), function (item) {
                                var jqueryObject = angular.element(item);
                                var text = jqueryObject.text();
                                if (that.currentPage === that.totalPages && (text === ">" || text === ">>")) {
                                    jqueryObject.addClass('disabled');
                                } else if (that.currentPage === 1 && (text === "<" || text === "<<")) {
                                    jqueryObject.addClass('disabled');
                                } else {
                                    jqueryObject.removeClass('disabled');
                                }
                                if (text === that.currentPage.toString()) {
                                    jqueryObject.addClass('active');
                                } else {
                                    jqueryObject.removeClass('active');
                                }
                            });
                        } else {
                            instanceElement.empty();
                        }
                    };
                    scope.$on('pageLoadCompleted', function () {
                        refresh(false);
                    });
                    scope.$on('searchCompleted', function () {
                        refresh(true);
                    });
                };
            }
            PaginationDirective.createButton = function (label, clickEvent) {
                var button = angular.element('<li><a href=#>' + label + '</a></li>');
                button.click({ page: label }, clickEvent);
                return button;
            };
            return PaginationDirective;
        })(app.directives.BaseDirective);
        directives.PaginationDirective = PaginationDirective;

        var ReportDirective = (function (_super) {
            __extends(ReportDirective, _super);
            function ReportDirective(utilities) {
                _super.call(this);
                this.restrict = 'A';
                this.scope = {
                    reportSource: '=',
                    reportName: '='
                };
                this.link = function (scope, element) {
                    element.html('<div><iframe style="border: transparent"></iframe></div>');
                    scope.$watch('reportSource', function (value) {
                        if (value) {
                            var frame = element.find('iframe');
                            frame.attr('src', value);
                            utilities.showMessage(element.html(), true, null, scope.reportName);
                        }
                    });
                };
            }
            return ReportDirective;
        })(app.directives.BaseDirective);
        directives.ReportDirective = ReportDirective;

        angular.module('app.directives.Common', []).directive('noClick', [function () {
                return new app.directives.NoClickDirective();
            }]).directive('pagination', [function () {
                return new app.directives.PaginationDirective();
            }]).directive('report', [
            'utilities', function (utilities) {
                return new app.directives.ReportDirective(utilities);
            }]);
    })(app.directives || (app.directives = {}));
    var directives = app.directives;
})(app || (app = {}));
//# sourceMappingURL=commonDirectives.js.map
